// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Algorithms/inc/InterferenceFunctionStrategies.h
//! @brief     Includes several files named *Strategy.h
//!
//! @homepage  http://apps.jcns.fz-juelich.de/BornAgain
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Jülich GmbH 2013
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#ifndef INTERFERENCEFUNCTIONSTRATEGIES_H_
#define INTERFERENCEFUNCTIONSTRATEGIES_H_

#include "IInterferenceFunctionStrategy.h"
#include "DecouplingApproximationStrategy.h"
#include "IsGISAXSMorphologyFileStrategy.h"
#include "LocalMonodisperseApproximationStrategy.h"
#include "SizeSpacingCorrelationApproximationStrategy.h"

#endif /* INTERFERENCEFUNCTIONSTRATEGIES_H_ */


